


Global Const $iScriptLanguageMode = 1;	Mode 1 fr .ini, 2 fr .xlsx

Global Const $sScriptLanguageFolder = @ScriptDir & "\Data\Language\"

Global Const $sScriptLanguageIniSection = "language"; Section Name in Ini File
Global Const $sScriptLanguageIniPrefix = "ID"; Prefix fr Language Entry

Global $iScriptLanguageIndex = 1; Edit for different Language Moduls
Global $sScriptLanguageFile ; Check $sScriptLanguageFolder for full Path
Global $aScriptLanguageFile ;		Array fr die Language Datei

Func _LanguageInit()
	Switch $iScriptLanguageIndex
		Case 1
			$sScriptLanguageFile = "german.lng"
		Case 2
			$sScriptLanguageFile = "english.lng"
	EndSwitch
	Local $path = $sScriptLanguageFolder & $sScriptLanguageFile
	Switch $iScriptLanguageMode
		Case 1
			_CheckLanguageInitINI($path)
			If @error Then Exit _ShowBox30(@error); -> Variable mit Language Datei lesen
		Case 2
			_CheckLanguageInitXLSX($path)
			If @error Then Exit _ShowBox30(@error); -> Variable mit Language Datei lesen
	EndSwitch
	Return 0
EndFunc   ;==>_LanguageInit

Func _CheckLanguageInitXLSX($path)
	If Not FileExists($path) Then Return SetError(1, 0, 0)
	$aScriptLanguageFile = _XLSXReadToArray($path)
	_ArrayDelete($aScriptLanguageFile, 0)
	Local $i = $aScriptLanguageFile[0][0]
	If $i < $sScriptLanguageVersion Then Return SetError(3, 0, 0)
	If IsArray($aScriptLanguageFile) = 0 Then Return SetError(2, 0, 0)
	For $i = 0 To UBound($aScriptLanguageFile) - 1 Step 1
		IniWrite($sScriptLanguageFolder & "german.lng", "language", "ID" & $i, "'" & $aScriptLanguageFile[$i][1] & "'")
	Next
	Return 1
EndFunc   ;==>_CheckLanguageInitXLSX

Func _CheckLanguageInitINI($path)
	If Not FileExists($path) Then Return SetError(1, 0, 0)
	Local $a = IniReadSection($path, $sScriptLanguageIniSection)
	If @error Then Return SetError(1, 0, 0)
	Return 1
EndFunc   ;==>_CheckLanguageInitINI

Func _LG($key, $mode)
	Local $ret = _LanguageGet($key, $mode)
	Return SetError(@error, @extended, $ret)
EndFunc   ;==>_LG

Func _LanguageGet($key)
	Local $error = 0
	Local $s = ""
	Switch $iScriptLanguageMode
		Case 1
			$s = IniRead($sScriptLanguageFolder & $sScriptLanguageFile, "language", $sScriptLanguageIniPrefix & $key, "")
		Case 2; .xlsx Variante
			If $key > UBound($aScriptLanguageFile) Then
				Return "Error with key: " & $key & " Error: -1"; -> Debug
			EndIf
			$s = $aScriptLanguageFile[$key][$iScriptLanguageIndex]
	EndSwitch
	If StringInStr($s, "@") Then
		$s = Execute($s)
		If @error Then $error = 1
	Else
		If StringInStr($s, '"') Then $s = Execute($s)
		If @error Then $error = 2
	EndIf
	If $s = "" And $error = 0 Then $error = 3
	If $error Then
		Return "Error with key: " & $error & " Error: " & $key ; -> Debug
	EndIf
	Return $s
EndFunc   ;==>_LanguageGet



